#!/bin/sh
#A proxima linha reinicia usando wish \
    exec wish "$0" "$@"

#"Copyright 2008, 2009 Professor Jose"

# Este programa é um software livre; você pode redistribui-lo e/ou 
# modifica-lo dentro dos termos da GNU LGPL como 
# publicada pela Fundação do Software Livre (FSF); na versão 2 da 
# Licença, ou (na sua opnião) qualquer versão.
#
# Este programa é distribuido na esperança que possa ser  útil, 
# mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAÇÂO a qualquer
# MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a
# Licença Pública Geral GNU para maiores detalhes.
#
# Você deve ter recebido uma cópia da Licença Pública Geral GNU
# junto com este programa, se não, escreva para a Fundação do Software
# Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


#Versão 02 do programa orion5star
#Considerando o uso do Starpack, mudamos os comandos para localizar
#a biblioteca objetos.tcl
#Nesta versão foi incluído recursos para o usuário configurar o programa
#para os eletrodos e unidades selecionados na tela do equipamento

#Versão 03 do programa orion5star
#Incluído tela para inserir informações sobre o experimento
#Armazenamento de dados com Metakit





wm title . "Orion 5 Star Thermo"

#Comando para o gerenciador de janelas para impedir o redimensionamento das janelas

wm resizable . 0 0

#Obtém o diretório atual do script

set dir [file dirname [info script]]

#Adiciona ao path de bibliotecas o diretório
#objLab (Objetos de Laboratório)
lappend auto_path [file join $dir objLab]

#Carrega a biblioteca de Objetos de Laboratorio
#objLab no diretório objLab
package require objLab

#Carrega a biblioteca Metakit para gerenciamento do banco de dados
package require Mk4tcl

#*************************************************************************************
#Criação dos frames principais para acomodar os elementos de interface para cada
#parâmetro, dentro dos quais podem ser criados frames filhos para organizar
#a posição dos elementos gráficos (widgets)
#*************************************************************************************

global fonte_grande fonte_media 

set fonte_grande {Times 24}

set fonte_media {Times 18}

#****************************************************************************
#Seleciona o nome da porta serial conforme o sistema operacional
#no qual o programa estiver rodando
#****************************************************************************

global nome_porta_serial

if {$tcl_platform(platform) == "unix"} {
        set nome_porta_serial "/dev/ttyS"
    } else {
        set nome_porta_serial "com"
    }

#*************************************************************************************
#Criação da tela de configuração
#************************************************************************************

#************************************************************************************
#Incluímos o comando trace que associa a chamada do procedimento inst toda vez que a 
#a variável PH, COND ou OD for modificada pois observamos a necessidade de criar
#primeiro os checkbuttons e depois criar a vinculação. Senão no momento da criação
#do checkbutton a rotina "remover eletrodo_$par" seria chamada sem ter um objeto 
#para ser removido
#***********************************************************************************


proc tela_config { janela_seguinte } {
    

    global par_monit fonte_media
    global pH_ISE COND OD
    global config    
    global unidade_ph_ise unidade_cond unidade_od

    global nome_porta_serial num_porta_serial
    
#set par_monit {"pH"  "Eletrodo de pH" {"pH" "pH"} "COND" "Condutividade" {"Conductivity" "uS/cm"} \
#    "OD" "Oxigênio Dissolvido" {"Concentration" "mg/L"} }


destroy .janela  
destroy .cfg



set config [frame .cfg]

set mensagem [label $config.msg -font $fonte_media -wraplength 7i -justify left -text "Programa para aquisição automática \
das leituras do potenciômetro \"Orion 5 STAR\" da \"Thermo\".\ 
Selecione os eletrodos instalados e as respectivas unidades. \n Bom Trabalho!"]



set config_ph_ise [labelframe $config.ph_ise -text "pH/ISE" ]
set config_cond   [labelframe $config.cond -text "Condutividade" ]
set config_od     [labelframe $config.od -text "Oxigênio Dissolvido" ]
set config_porta_serial     [labelframe $config.porta_serial -text "Porta Serial" ]



checkbutton $config_ph_ise.par_ph -text "pH/ISE" -font $fonte_media -variable pH_ISE -command ";#puts\$pH_ISE"

pack $config_ph_ise.par_ph

foreach { unidade1 unidade2 } { "pH" {"pH" "pH"} "mV" {"mV" "mV"} "RmV" {"Relative" "RmV"} "ISE:ppb" {"Concentration" "ppb"} } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_ph_ise.$nome_minusculo -text "$unidade1" -font $fonte_media -relief flat -anchor w  \
	-variable unidade_ph_ise -value $unidade2 -command ";#puts\$unidade_ph_ise"
    
    pack $config_ph_ise.$nome_minusculo -side top -anchor w
    
}



checkbutton $config_cond.par_cond -text "Cond" -font $fonte_media -variable COND -command ";#puts\$COND"

pack $config_cond.par_cond

foreach { unidade1 unidade2 } { "uS/cm" {"Conductivity" "uS/cm"} "mg/L" {"TDS" "mg/L"} "ppt" {"Salinity" "ppt"} "Mohm-cm" {"Resistivity" "Mohm-cm"} } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_cond.$nome_minusculo -text "$unidade1" -font $fonte_media -relief flat -anchor w  \
	-variable unidade_cond -value $unidade2 -command ";#puts\$unidade_cond"
    
    pack $config_cond.$nome_minusculo -side top -anchor w
    
}



checkbutton $config_od.par_od -text "OD" -font $fonte_media -variable OD -command ";#puts\$OD"

pack $config_od.par_od

foreach { unidade1 unidade2 } { "mg/L" {"Concentration" "mg/L"} "% sat" {"Saturation" "% sat"} } {
    
    set nome_minusculo [string tolower $unidade1]
    
    radiobutton $config_od.$nome_minusculo -text "$unidade1" -font $fonte_media -relief flat -anchor w  \
	-variable unidade_od -value $unidade2 -command ";#puts\$unidade_od"
    
    pack $config_od.$nome_minusculo -side top -anchor w
    
}


label $config_porta_serial.nome_porta_serial -font $fonte_media -text $nome_porta_serial
spinbox $config_porta_serial.numero_porta_serial -from 0 -to 10 -bg white -font $fonte_media \
-textvariable num_porta_serial -width 2

pack $config_porta_serial.nome_porta_serial  $config_porta_serial.numero_porta_serial -side left


set botao [frame $config.bt]




button $botao.continuar -text "Continuar" -font $fonte_media  -command continuar


button $botao.sair -text "Sair" -font $fonte_media -command "exit"

pack $botao.continuar $botao.sair -side left -expand yes 

pack $mensagem -side top

pack $botao -side bottom -expand yes -fill x -pady 8

pack $config_ph_ise $config_cond $config_od $config_porta_serial -side left -pady 8 -expand yes

pack $config



}

#*************************************************************************************
#Criação do procedimento para montar a lista de parâmetros monitorados
#*************************************************************************************


proc continuar {} {
    
    global pH_ISE COND OD
    
    global unidade_ph_ise unidade_cond unidade_od
    
    global nome_porta_serial num_porta_serial porta_serial
    
    global config par_monit
    
    
    if { !($pH_ISE) && !($COND) && !($OD) } { 
	tk_messageBox -message "Por favor, selecione pelo menos \"1\" eletrodo!" 
	return
    }
    
    
    
    ;#puts"$pH_ISE $COND $OD"
    
    set par_monit {}
    
    if { $pH_ISE } {
	
	lappend par_monit pH_ISE
	lappend par_monit "Eletrodo de pH/ISE"
	lappend par_monit $unidade_ph_ise
	
    }
    
    if { $COND } {
	
	lappend par_monit COND
	lappend par_monit "Condutividade"
	lappend par_monit $unidade_cond
	
    } 
    
    if { $OD } {
	
	lappend par_monit OD
	lappend par_monit "Oxigênio Dissolvido"
	lappend par_monit $unidade_od
    }
    
    set porta_serial {}
    set nome $nome_porta_serial
    set numero $num_porta_serial

    if {[string equal $nome "/dev/ttyS"]} {
	set porta_serial [append nome $numero]
    } else {
	set porta_serial [append nome $numero ":"]
    }
    
    
    ;#puts"porta_serial = $porta_serial"
    
    tela_monit  $config
    
    vincular_objetos $par_monit
    
    
    
    return
    
}

#*************************************************************************************
#Criação do procedimento para vincular o checkbox com a rotina de criação de objetos
#*************************************************************************************


proc vincular_objetos lista {

global pH_ISE COND OD

set pH_ISE 0
set COND 0
set OD 0

foreach {p n u} $lista { trace add variable $p   write [list inst $p $u] }

return

}



#*************************************************************************************
#Criação da tela de monitoramento
#************************************************************************************


proc tela_monit { janela_anterior } {
    
destroy .janela    
    
    global fonte_media fonte_grande porta_serial par_monit
    
    pack forget $janela_anterior
    
    ;#puts"par_monit = $par_monit"
    
   
    
    set janela_atual [frame .janela] 
    
    foreach { par nome unidade } $par_monit {
	
	global leituras_dados_$par
	
	
#*************************************************************************************
#Criação dos frames principais para acomodar os elementos de interface para cada
#parâmetro, dentro dos quais podem ser criados frames filhos para organizar
#a posição dos elementos gráficos (widgets)
#Estamos usando a estratégia de dereferenciar, quando uma variável contém o nome
#de outra variável e esta armazena a informação
#Fonte: http://phaseit.net/claird/comp.lang.tcl/tcl_deref.html
#*************************************************************************************
	
	set janela_$par [labelframe $janela_atual.[string tolower $par]  -text "$nome" -font $fonte_media]
	
	
#*************************************************************************************
#Criação dos frames principais para acomodar os elementos  checkbox e janela de texto
#com as leituras
#*************************************************************************************

	
	set frame_cb_$par [frame [set janela_$par].selec]
	
	
#*************************************************************************************
#Checkbuttons para ativar ou desativar a aquisição de cada eletrodo individualmente
#*************************************************************************************

#*************************************************************************************
#O procedimento config_label foi um "remendo" para poder reconfigurar o label do checkbox
#*************************************************************************************


	set cb_$par [checkbutton [set frame_cb_$par].cb \
			 -text "Desativado" -font $fonte_media \
			 -variable $par -relief flat \
			 -command [list config_label [set frame_cb_$par].cb $par]]
	
	set frame_dados_$par [frame [set janela_$par].texto]
	
	
#*************************************************************************************
#Janelas de texto para as leituras de pH
#*************************************************************************************

	set menu_$par [frame [set frame_dados_$par].barramenu -relief raised]
	
	
	set menu_arq_$par [menubutton [set menu_$par].arquivo -text " Arquivo "  -relief raised -menu [set menu_$par].arquivo.opcoes]
	
	
	menu [set menu_$par].arquivo.opcoes
	[set menu_$par].arquivo.opcoes add command -label "Gravar     " -command " gravar_arquivo [set frame_dados_$par].leituras "
	[set menu_$par].arquivo.opcoes add command -label "Abrir      " -command " abrir_arquivo  [set frame_dados_$par].leituras "
	
	
	set leituras_dados_$par [text [set frame_dados_$par].leituras -relief sunken -yscrollcommand "[set frame_dados_$par].rolagem set" -background white -width 30 -height 6]
	
	set rolagem_dados_$par [scrollbar [set frame_dados_$par].rolagem -command "[set frame_dados_$par].leituras yview"]
	
	
	pack [set cb_$par] -side left -expand yes -anchor w
	
	pack [set menu_$par] -side top -fill x
	
	pack [set menu_arq_$par] -fill x 
	
	pack [set leituras_dados_$par] [set rolagem_dados_$par] -side left -expand yes -fill both
	
	pack [set frame_cb_$par] [set frame_dados_$par] -side left -expand yes -fill both
	
	pack [set janela_$par] -anchor w -pady 8 -expand yes -fill both 
	
}
    
    
     
    #***********************************************************************
    #Criação dos botões para controle do programa
    #Usamos os colchetes e ";" para permitir a substituição de variáveis
    #nos procedimentos incluídos na opção command
    #***********************************************************************
    
set janela_botoes [frame $janela_atual.b]
    
button  $janela_botoes.iniciar  -text "Iniciar Leitura"  -command " [list iniciar_leitura $porta_serial] ; \
[list $janela_botoes.iniciar configure -state disable]; \
    [list $janela_botoes.configurar configure -state disable] "


button $janela_botoes.parar -text "Parar  Leitura" \
-command [list alerta_parar_leitura $janela_botoes]


button $janela_botoes.sair -text "Sair"  -command { 
    parar_leitura
    exit
}

button $janela_botoes.configurar -text "Reconfigurar" -command " [list voltar_config $janela_atual] "


pack $janela_botoes.iniciar $janela_botoes.parar $janela_botoes.configurar $janela_botoes.sair \
    -side left -expand yes -fill x

pack $janela_botoes -side bottom -expand yes -fill both

pack $janela_atual

}

###########################################################################
#Procedimento para alertar que parada de leitura vai parar também um 
#experimento
###########################################################################


proc alerta_parar_leitura { janela_botoes } {
    
    global estado_experimento  
    
    puts "Dentro de alerta_parar_experimento e estado_experimento => $estado_experimento"
    
    if { $estado_experimento } {
	    
	    set resposta [tk_dialog .parar_leitura "Parada do Experimento"  \
		"Se interromper as leituras vai parar também o experimento que está em andamento! \n \
Deseja Cancelar ou Continuar esta operação?"  info 0 Cancelar Continuar]
	    switch $resposta {
		0 {}
		1 {
		    parar_leitura
		    $janela_botoes.iniciar configure -state normal
		    $janela_botoes.configurar configure -state normal
		    parar_experimento
		}    
	    }
	} else {
	    parar_leitura
	    $janela_botoes.iniciar configure -state normal
	    $janela_botoes.configurar configure -state normal
	}	
}

#*************************************************************************************
#Um procedimento para "alertar" o usuário para salvar as leituras antes de voltar
#para a tela de configuração
#Usamos a janela tk_dialog para oferecer 2 opções:
#0- Cancelar e permanecer na tela atual
#1- Continuar e voltar para a tela de configuração 
#*************************************************************************************

proc voltar_config { janela } {

    global pH_ISE COND OD    
    global par_monit
    
    set resposta [tk_dialog $janela.reconfigurar "Reconfigurar!"  "Você já salvou as leituras realizadas?"  info 0 Cancelar Continuar]
    switch $resposta {
	0 {}
	1 {
	   foreach {p n u} $par_monit { trace remove variable $p   write [list inst $p $u]}
	    tela_config $janela
	}
    }
    
}


#*************************************************************************************
#Um "remendo" para poder reconfigurar o label do checkbox
#*************************************************************************************


proc config_label { cb par } {
    
    global $par
    if {[set $par]} {
	$cb configure -text "  Ativado   "
    } else {
	$cb configure -text "Desativado"
    }
    
}


#***********************************************************************
#Procedimento criado para gravar os conteúdo de um "text" em um arquivo.
#***********************************************************************

proc gravar_arquivo { janela } {
    
    set dados [$janela get 1.0 {end -1c}]
    set tipo_arquivo {
	{"Arquivos de Leituras" { .csv } }
	{"Arquivos de Texto"    { .txt } }
	{"Arquivos de Eventos" { .log } }
	{"Todos os arquivos" * }
    }
    set nome_arquivo [tk_getSaveFile -filetypes $tipo_arquivo -initialdir pwd]
    if {[catch {set id_arquivo [open $nome_arquivo w]} result] != 0} {
	return
    }
    puts -nonewline $id_arquivo $dados
    close $id_arquivo
}

#****************************************************************************
#Procedimento criado para abrir os conteúdo de um arquivo em uma janela text.
#****************************************************************************

proc abrir_arquivo { janela } {
    set tipo_arquivo {
	{"Arquivos de Leituras" { .csv } }
	{"Arquivos de Texto"    { .txt } }
	{"Arquivos de Eventos" { .log } }
	{"Todos os arquivos" * }
    }
    
    if {[catch {set nome_arquivo [tk_getOpenFile -filetypes $tipo_arquivo -initialdir pwd]} result] !=0 } {
	return
    }
    if {[catch {set id_arquivo [open $nome_arquivo r]} result] != 0 } {
	return
    }
    set dados [read $id_arquivo ]
    close $id_arquivo
    $janela delete 1.0 end
    $janela insert end $dados
}








#***********************************************************************
#Procedimento criado para abrir a porta serial
#Neste procedimento podemos incluir os parâmetros de comunicação 
#do equipamento
#***********************************************************************


proc abrir_porta { nome_porta } {
    
global id_porta

    set baud 9600
    set paridade n
    set bit_dados 8
    set bit_parada 1
    
    set resultado_1 [ catch { set id_porta [open $nome_porta r+] } ]
    
    set resultado_2 [catch {fconfigure $id_porta -mode "$baud,$paridade,$bit_dados,$bit_parada" }]
    
    if { ($resultado_1 != 0) || ($resultado_2 != 0) } {
	set id_porta "SERIAL_ERRO_OPEN"
	return $id_porta
    } else {
	return $id_porta
    }

#set dir [file dirname [info script]]
#set id_porta [open "|tclsh [file join $dir simu_orion.tcl]" r+]
#set id_porta [open "|[file join $dir simu_orion.tcl]" r+]
fconfigure $id_porta -buffering line
return $id_porta
}


proc iniciar_leitura { porta_fisica } {
    
    global t_inicial
    global estado_experimento
    set estado_experimento 0
    
    cadastrar_experimento

    set t_inicial [clock clicks -milliseconds]
    
#puts "t_inicial $t_inicial"
    
    set id_porta [abrir_porta $porta_fisica]

#puts "id_porta = $id_porta"
    if {$id_porta != "SERIAL_ERRO_OPEN"} {
	fileevent $id_porta readable [list ler_porta $id_porta]
    }
    
}


proc parar_leitura { } {

global id_porta

#puts "comando catch retorna [catch {tell $id_porta}]"

if {![catch {tell $id_porta}]} {
   
#puts "porta $id_porta fechada"
close $id_porta
set id_porta {}

}

return

}



#****************************************************************************
#Cria (ou remove) os objetos da classe instrumento conforme os checkboxes
#são ativados ou desativados na interface.
#Este procedimento será chamado toda vez que a variável pH, COND ou OD 
#for modificada, vinculação criada pelo comando "trace"
#No momento da criação do objeto eletrodo aproveitamos para definir a
#unidade de leitura que corresponde ao segundo elemento da lista
#unidade
#****************************************************************************

proc inst { args } {
    
    upvar \#0 [lindex $args 0] par
    set nome_par [lindex $args 0]
    set nome_unid_par [lindex $args 1]

    global frame_cb_$nome_par.cb
    
    if { $par } {
	
	puts "criando instrumento eletrodo_$nome_par e \$par : $par"
	puts "Unidade: [lindex $nome_unid_par 1]"
	instrumento eletrodo_$nome_par
	eletrodo_$nome_par def_unidade [lindex $nome_unid_par 1]
	
	
    } else {
	
	puts "removendo instrumento eletrodo_$nome_par e \$par : $par"
	remover_instrumento eletrodo_$nome_par
	
    }
}





proc ler_porta { canal } {
    
    global t_inicial   par_monit
    global estado_experimento    
    
    #Comando para calcular o tempo atual em milisegundos   
    set t_final [clock clicks -milliseconds]
    
    if { [eof $canal ] } {
	;#puts stderr "Fechando $canal"
	catch { close $canal }
	return 
    }
    
    
    set l [gets $canal]
    
    foreach {p n u} $par_monit {
	
	global $p leituras_dados_$p 
	
	if { [set $p] } {
	    
	    if {([regexp (^[lindex $u 0]) $l unidade0]) && ([regexp ([lindex $u 1]$) $l unidade1])} { 

		;#puts "primeira regexp = [regexp (^[lindex $u 0]) $l unidade0] e segunda regexp = [regexp ([lindex $u 1]$) $l unidade1]"
				
		regexp {(-)*[0-9]+(\.)*[0-9]+} $l l_$p	    
		
		;#puts "Parâmetro $p = [set $p] leitura [set l_$p] e unidades = $unidade0 e $unidade1" 
		
		#Comando para calcular o tempo decorrido desde t0 em minutos
		set t_final [format "%.2f" [expr ($t_final - $t_inicial)/60000.0]]
		
		#Comando regsub usado para substituir as ocorrências de . por , 
		#É possível usar \\. e \\, ou {\.} e {,} ou {,}
		set t_final [regsub {\.} $t_final \, ]
		set l_$p [regsub {\.} [set l_$p] {,} ]
		
		[set leituras_dados_$p] insert end "$t_final (min)  [set l_$p]  ($unidade1)\n"
		[set leituras_dados_$p] see end


#Se houver um experimento em andamento então chamamos o procedimento 
#que inicia o uso do objeto da classe medida

if { $estado_experimento } {

iniciar_medida $p $t_final min  [set l_$p]

}
		return
		
	    }
    
	}
    }
}

##############################################################################
#Procedimento para criação de um objeto da classe "medida"
##############################################################################

proc iniciar_medida {parametro tempo unid_tempo leitura} {
    
    global codigo_amostra
 
#Array no formato lista_medidas(parametro) para armazenar as leituras de um 
#experimento

    global lista_medidas   
    
    set pos_par_lista_par_monit \
	[lsearch [get_parametros_monitorados $codigo_amostra] $parametro]	

    if { ($pos_par_lista_par_monit != -1) } {
	    
	    eletrodo_$parametro def_leitura [list $tempo $leitura]
	    
#################################################################
#Comando para a criação de um objeto da classe medida cujo
#nome é o próprio nome do parâmetro monitorado
#################################################################
	    
	    medida medida_$parametro
	    
	    medida_$parametro def_amostra_medida $codigo_amostra
	    
	    medida_$parametro def_parametro_medido $parametro

	    lappend lista_medidas($parametro) \
		[lindex [eletrodo_$parametro get_leitura] 0]

	    lappend lista_medidas($parametro) \
		[lindex [eletrodo_$parametro get_leitura] 1]

# puts "LISTA_MEDIDAS => $lista_medidas($parametro)"
	    medida_$parametro def_leituras $lista_medidas($parametro)
	    

	    puts "parametro $parametro tempo $tempo unid_tempo $unid_tempo leitura $leitura unid_leitura [eletrodo_$parametro get_unidade]\n"
#puts [eletrodo_$parametro get_leitura]
#puts [$codigo_amostra get_projeto]	    
#puts [$codigo_amostra get_experimento]
#puts [$codigo_amostra get_responsavel_experimento]
#puts [$codigo_amostra get_coleta]    
#puts [clock format [lindex [$codigo_amostra get_coleta] 1] \
	    -format {%d/%m/%Y %H:%M}]
#puts [$codigo_amostra get_parametros_monitorados]
	    	    
	        
#puts "Código da amostra medida [medida_$parametro get_amostra_medida]"
#puts "Parâmetro monitorado [medida_$parametro get_parametro_medido]"
	    
#puts "****LEITURAS REALIZADAS [medida_$parametro get_leituras]****"

#Procedimento para arquivar a medida realizada

	    arquivar_medida medida_$parametro

	    remover_medida medida_$parametro

	}
	
	return
	
}


##############################################################################
#Procedimento para cadastrar os dados do experimento
##############################################################################

proc cadastrar_experimento { } {
    
    
    destroy .id_exp
    toplevel .id_exp
    
    wm title .id_exp "Cadastrar Experimento"
    
    wm resizable .id_exp 0 0

set tam_entry 15
    
    global fonte_media
    global cod_proj coord_proj num_exp resp_exp local_col resp_col 
    global data_coleta_dia data_coleta_mes data_coleta_ano data_coleta_hora data_coleta_min
    global par_monit
    global estado_experimento
   
    message .id_exp.msg  -justify left -width [expr 40 * $tam_entry]  -font fonte_media -text "Por favor, forneça as informações sobre o experimento. Obrigado!"
    
    pack .id_exp.msg -expand yes -fill both
    
    #
    #Este loop cria os frames do tipo labelframe contendo as entradas para as informações
    #sobre o experimento
#
    
    frame .id_exp.info
    
    labelframe .id_exp.info.proj -font fonte_media -text "Projeto:"
  
    label .id_exp.info.proj.cod_proj_l -font fonte_media -text "Código:"
    entry .id_exp.info.proj.cod_proj_e -width $tam_entry -bg white -textvariable cod_proj
    pack .id_exp.info.proj.cod_proj_l .id_exp.info.proj.cod_proj_e -side left \
	-expand yes -fill both 

    label .id_exp.info.proj.coord_proj_l -font fonte_media -text "    Coordenador:"
    entry .id_exp.info.proj.coord_proj_e -width $tam_entry -bg white -textvariable coord_proj
    pack .id_exp.info.proj.coord_proj_l .id_exp.info.proj.coord_proj_e -side left \
	-expand yes -fill both

    pack .id_exp.info.proj -expand yes -fill both -pady 8
    
    
    labelframe .id_exp.info.exp -font fonte_media -text "Experimento:"
    
    label .id_exp.info.exp.num_exp_l -font fonte_media -text "Número:"
    entry .id_exp.info.exp.num_exp_e -width $tam_entry -bg white -textvariable num_exp
    pack .id_exp.info.exp.num_exp_l .id_exp.info.exp.num_exp_e -side left \
	-expand yes -fill both
    
    label .id_exp.info.exp.resp_exp_l -font fonte_media -text "    Responsável:"
    entry .id_exp.info.exp.resp_exp_e -width $tam_entry -bg white -textvariable resp_exp
    pack .id_exp.info.exp.resp_exp_l .id_exp.info.exp.resp_exp_e -side left \
	-expand yes -fill both
    
    pack .id_exp.info.exp -expand yes -fill both -pady 8


    labelframe .id_exp.info.col -font fonte_media -text "Coleta da Amostra:"
    
    label .id_exp.info.col.local_col_l -font fonte_media -text "Local:"
    entry .id_exp.info.col.local_col_e -width $tam_entry -bg white -textvariable local_col
    pack .id_exp.info.col.local_col_l .id_exp.info.col.local_col_e -side left \
	-expand yes -fill both
    
    label .id_exp.info.col.resp_col_l -font fonte_media -text "    Responsável:"
    entry .id_exp.info.col.resp_col_e -width $tam_entry -bg white -textvariable resp_col
    pack .id_exp.info.col.resp_col_l .id_exp.info.col.resp_col_e -side left \
	-expand yes -fill both
    
    pack .id_exp.info.col -expand yes -fill both -pady 8


    
    #Campos para entrada de data e hora de amostragem
    #Vão armazenar as variáveis:  data_coleta_dia,  data_coleta_mes e  data_coleta_ano
    #contendo respectivamente o dia mes e ano da amostragem
    
labelframe .id_exp.info.data_hora -font fonte_media -text "Data e Hora da Coleta"

    frame .id_exp.info.data_hora.data 
       
    label .id_exp.info.data_hora.data.d_l -font fonte_media -text "Dia"
    spinbox .id_exp.info.data_hora.data.d  -from 1 -to 31  -validate key \
	-vcmd {string is integer %P} -width 2 -bg white \
	-font fonte_media -textvariable  data_coleta_dia
    
    label .id_exp.info.data_hora.data.m_l -font fonte_media -text "Mes"
    spinbox .id_exp.info.data_hora.data.m  -from 1 -to 12  -validate key \
	-vcmd {string is integer %P} -width 2 -bg white \
	-font fonte_media -textvariable  data_coleta_mes
    
    label .id_exp.info.data_hora.data.a_l -font fonte_media -text "Ano"
    spinbox .id_exp.info.data_hora.data.a  -from 2009 -to 2050  -validate key \
	-vcmd {string is integer %P} -width 4 -bg white \
	-font fonte_media -textvariable  data_coleta_ano


    grid .id_exp.info.data_hora.data.d_l  .id_exp.info.data_hora.data.m_l  \
	.id_exp.info.data_hora.data.a_l
    grid .id_exp.info.data_hora.data.d  .id_exp.info.data_hora.data.m  \
	.id_exp.info.data_hora.data.a
    

    frame .id_exp.info.data_hora.hora
   

    label .id_exp.info.data_hora.hora.h_l -font fonte_media -text "Hora-24h"
    spinbox .id_exp.info.data_hora.hora.h  -from 0 -to 23  -validate key \
	-vcmd {string is integer %P} -width 2 -bg white \
	-font fonte_media -textvariable  data_coleta_hora

    label .id_exp.info.data_hora.hora.min_l -font fonte_media -text "Min."
    spinbox .id_exp.info.data_hora.hora.min  -from 0 -to 60  -validate key \
	-vcmd {string is integer %P} -width 2 -bg white \
	-font fonte_media -textvariable  data_coleta_min

    grid .id_exp.info.data_hora.hora.h_l  .id_exp.info.data_hora.hora.min_l
    grid .id_exp.info.data_hora.hora.h  .id_exp.info.data_hora.hora.min

 pack  .id_exp.info.data_hora.data .id_exp.info.data_hora.hora  -side left



pack .id_exp.info.data_hora  -pady 8 


#Frame que armazena os parâmetros monitorados com os respectivos limites (sup e inf)

labelframe .id_exp.info.par_monit -font fonte_media -text "Parâmetros Monitorados"
pack  .id_exp.info.par_monit

set c 0

    foreach {p n u} $par_monit {
	
	checkbutton .id_exp.info.par_monit.[string tolower $p] -text "$n" -font $fonte_media -variable par_monit_$p 
	label .id_exp.info.par_monit.label_lim_sup_[string tolower $p] -font fonte_media -text "Limite Superior"
	entry .id_exp.info.par_monit.entry_lim_sup_[string tolower $p] -width 10 -bg white -textvariable lim_sup_$p
	
	label .id_exp.info.par_monit.label_lim_inf_[string tolower $p] -font fonte_media -text "Limite Inferior"
	entry .id_exp.info.par_monit.entry_lim_inf_[string tolower $p] -width 10 -bg white -textvariable lim_inf_$p

	grid .id_exp.info.par_monit.[string tolower $p] -row 0 -column $c -columnspan 2
	grid .id_exp.info.par_monit.label_lim_sup_[string tolower $p] -row 1 -column $c
	grid .id_exp.info.par_monit.entry_lim_sup_[string tolower $p] -row 1 -column [expr $c + 1]

	grid .id_exp.info.par_monit.label_lim_inf_[string tolower $p] -row 2 -column $c
	grid .id_exp.info.par_monit.entry_lim_inf_[string tolower $p] -row 2 -column [expr $c + 1]

	incr c 2
    } 
    
   

    
    labelframe .id_exp.coment -font fonte_media -text "Comentários:"
    text .id_exp.coment.txt -width 30 -height 5 \
	-yscrollcommand { .id_exp.coment.rlg set} -background white
    scrollbar .id_exp.coment.rlg -command { .id_exp.coment.txt yview }
    pack .id_exp.coment.txt -side left -expand yes -fill both
    pack .id_exp.coment.rlg -side right -fill y
    
    frame .id_exp.b
    
    button .id_exp.b.continuar -font $fonte_media -text "Iniciar Experimento" \
	-command iniciar_experimento

    button .id_exp.b.parar -font $fonte_media -text "Parar Experimento" \
	-command parar_experimento

    button .id_exp.b.consultar_db -font $fonte_media -text "Banco de Dados"

    button .id_exp.b.cancelar -font $fonte_media -text "Fechar" -command { destroy .id_exp }
    
    pack .id_exp.b.continuar .id_exp.b.parar .id_exp.b.consultar_db .id_exp.b.cancelar -side left -expand yes -fill both
    
    pack .id_exp.info .id_exp.coment  .id_exp.b -expand yes -fill both -side top


}

##############################################################################
#Procedimento para iniciar um experimento
#Este procedimento realiza várias ações:
#1-reinicializa a variável global array lista_medidas(parametro) que armazena
#as leituras de cada parâmetro
#2-inicializa a lista lista_par_monit_amostra com os parâmetros que serão
#monitorados neste experimento e os respectivos limites sup e inf
#Inicializa as seguintes variáveis:
#cod_proj => código do projeto
#coord_proj => coordenador do projeto
#num_exp => número do experimento
#resp_exp => responsável pelo experimento
#local_col => local da coleta
#data_col => data da coleta (format epoch)
#resp_col => responsável pela coleta
#data_coleta_dia
#data_coleta_mes
#data_coleta_ano
#data_coleta_hora
#data_coleta_min
#Cria um objeto "amostra" e configura os respectivos atributos
###############################################################################


proc iniciar_experimento {} {
    
    global estado_experimento
    global codigo_amostra
    global par_monit
    global cod_proj coord_proj num_exp resp_exp local_col resp_col
    global data_coleta_dia data_coleta_mes data_coleta_ano data_coleta_hora data_coleta_min

#Array no formato lista_medidas(parametro) para armazenar as leituras de um 
#experimento
    global lista_medidas
    
#Comando para limpar o conteúdo da variável lista_medidas do experimento
#anterior
    if { [info exists lista_medidas] } { unset lista_medidas }
	


set lista_par_monit_amostra {}

    foreach {p n u} $par_monit {

	global par_monit_$p lim_sup_$p lim_inf_$p

	if { [set par_monit_$p] } {
		lappend lista_par_monit_amostra $p
		lappend lista_par_monit_amostra [set lim_sup_$p]
		lappend lista_par_monit_amostra [set lim_inf_$p]
	    }

    }

    if {![llength $lista_par_monit_amostra]} {
	    tk_messageBox \
		-message "Por favor, selecione pelo menos \"1\" sensor!" \
		-parent .id_exp
	    return
	}
	

.id_exp.b.continuar configure -state disable
.id_exp.b.cancelar configure -state disable



    set estado_experimento 1

    set codigo_amostra [clock seconds]

#Criação de um objeto da classe amostra cujo nome é a hora
#local no formato epoch

    amostra $codigo_amostra

#Armazena a lista contendo os parâmetros monitorados no experimento
#atual com os respectivos limites sup e inf

    puts "Lista de par monitorados na amostra: $lista_par_monit_amostra"

    $codigo_amostra def_parametros_monitorados $lista_par_monit_amostra

    $codigo_amostra def_projeto $cod_proj $coord_proj 
   
    $codigo_amostra def_experimento $num_exp andamento

    $codigo_amostra def_responsavel_experimento $resp_exp 


#Comando que passou a apresentar problemas quando mudei da versão 8.5 para 8.4
#    set data_col [clock scan "$data_coleta_dia $data_coleta_mes \
#	$data_coleta_ano $data_coleta_hora $data_coleta_min" \
#	-format {%d %m %Y %H %M}]

#Inclui as barras e mudei a posição da variável mes pela variável dia 
#Para ficar de acordo com o padrão americano e evitar erro
#Essa alteração foi necessária após mudar o interpretador Tcl da versão
#8.4 para a versão 8.5

set data_col [clock scan "$data_coleta_mes/$data_coleta_dia/$data_coleta_ano $data_coleta_hora:$data_coleta_min"]
    
puts "Data coleta $data_col"

#Armazena as informações sobre a coleta {local data responsavel}

    $codigo_amostra def_coleta $local_col $data_col $resp_col

#Procedimento para arquivar os dados cadastrais do experimento

    arquivar_experimento $codigo_amostra    
}


##############################################################################
#Procedimento para parar o experimento o qual vai executar as seguintes ações:
#1-atribuir à variável estado_experimento o valor "0"
#2-arquivar o conteúdo do campo comentários no banco de dados consultando
#o registro da tabela "cadastro" usando o conteúdo da variável num_cad_exp
#3-habilitar os botões "Iniciar Experimento" "Fechar" da tela de cadastramento
#4-remover o objeto "amostra"
############################################################################## 


proc parar_experimento {} {
    
    global estado_experimento
    global codigo_amostra
    global reg_cad_exp
    
    if {[msg_alerta .id_exp "Deseja Realmente \"Parar\" o Experimento?"]} {
	    
	    set estado_experimento 0
	    
	    set coment_exp [.id_exp.coment.txt get 1.0 {end -1c}]
	    
	    mk::file open db orion5star.db
	    
	    mk::set $reg_cad_exp coment_exp $coment_exp
	    
	    mk::file commit db
	    
	    mk::file close db
	    
	    .id_exp.b.continuar configure -state normal
	    .id_exp.b.cancelar configure -state normal
	    
	    remover_amostra $codigo_amostra 
	}
	
}


##############################################################################
#Procedimento para arquivar as informações do cadastro do experimento no 
#banco de dados:
#1-Cria o banco de dados se ele ainda não existe
#2-Resgata os atributos do objeto do tipo amostra e armazena no array exp
#3-Arquiva o conteúdo do array "exp" no banco de dados e guarda a localização
#do registro na variável reg_cad_exp que será usada pelo procedimento 
#parar_experimento para armazenar o conteúdo do campo "comentários" 
#4-Isere na tabela db.medidas os registros para as leituras dos parâmetros
#que serão monitorados durante o experimento usando o mesmo id do registro do
#experimento
##############################################################################

proc arquivar_experimento { info_amostra } {
    
    global reg_cad_exp   
    
#Array no formato reg_cad_med(parametro) para armazenar o número do
#registro na tabela de resultados "db.medida" para agilizar o arquivamento
#das medidas

    global reg_cad_med 


	if {![file exists "orion5star.db"]} {
		
		criar_db
	    }
	    
	    
	    puts "Projeto(código e coordenador): [$info_amostra get_projeto]"
	    set exp(cod_proj) [lindex [$info_amostra get_projeto] 0]
	    set exp(coord_proj) [lindex [$info_amostra get_projeto] 1] 
	    
	    puts "Experimento (número status): [$info_amostra get_experimento]"
	    set exp(num_exp) [lindex [$info_amostra get_experimento] 0]
	    
	    puts "Responsável Experimento: \
[$info_amostra get_responsavel_experimento]"
	    set exp(resp_exp) [$info_amostra get_responsavel_experimento]
	    
	    set exp(local_col) [lindex [$info_amostra get_coleta] 0]
	    set exp(data_col)  [lindex [$info_amostra get_coleta] 1]
	    set exp(resp_col)  [lindex [$info_amostra get_coleta] 2]
	    puts "Coleta(local data resp): [$info_amostra get_coleta]"
	    
	    puts "Data Coleta: [clock format \
[lindex [$info_amostra get_coleta] 1] -format {%d/%m/%Y %H:%M}]"
	    
	    
	    set exp(lst_par_monit_amostra) [$info_amostra get_parametros_monitorados] 
	    puts "Parâmetros monitorados(p l_inf l_sup): \
[$info_amostra get_parametros_monitorados]"
	    
	    
	    
	    
	    mk::file open db orion5star.db
	    
	    set exp(id_cad_exp) [getuniqueid db]


	    puts "SAÍDA DO ARRAY GET **EXP** [array get exp]"
	    
	    set reg_cad_exp \
		[eval mk::row append db.cadastro [array get exp]]
	    puts "RETORNO DA INCLUSÃO NO CADASTRO DE EXPERIMENTO => $reg_cad_exp"

	    foreach {p n u} $exp(lst_par_monit_amostra) {
		
		set retorno [mk::row append db.medida \
		    id_cad_med $exp(id_cad_exp) parametro $p]  
		puts "RETORNO DA INCLUSÃO NO CADASTRO DE MEDIDAS => $retorno"
		set reg_cad_med($p) $retorno		
		
	    }

	    mk::file commit db
	    
	    mk::file close db
	    
	    	    
}

###########################################################################
#Procedimento para criação do banco de dados no arquivo orion5star.db
#É executado apenas quando o arquivo orion5star.db não existe
###########################################################################


proc criar_db {} {
    
puts "CRIANDO O BANCO DE DADOS ORION5STAR.DB"

    mk::file open db orion5star.db

#Criação da tabela para armazenar os dados cadastrais de um experimento
    
    set cad_exp [mk::view layout db.cadastro {id_cad_exp:L cod_proj:S \
	coord_proj:S num_exp resp_exp:S local_col:S data_col:L resp_col:S \
	coment:S lst_par_monit_amostra coment_exp}]
    
#Criação da tabela para armazenar as leituras de um parâmetro durante
#um experimento onde o campo id_cad_med será correspondente ao
#id_cad_exp no qual a medida foi gerada

    
    set cad_med [mk::view layout db.medida {id_cad_med:L parametro:S leituras}]
  
    set controle [mk::view layout db.cad_control {nextid:L}]
  
    mk::row append db.cad_control nextid 1

    puts "cad_exp => $cad_exp, cad_med => $cad_med e controle => $controle"
    
    mk::file close db

    
}

###########################################################################
#Procedimento para geração de chave primária para indexação dos registros
###########################################################################


proc getuniqueid { db } {
    
    set id [mk::get db.cad_control!0 nextid]
    
    mk::set db.cad_control!0 nextid [expr {$id + 1 }]
    
    mk::file commit db
    
    return $id
}


###########################################################################
#Procedimento para arquivar as medidas de um experimento
#Este procedimento utiliza o conteúdo do array global reg_cad_med 
#para atualizar a penas o campo leituras com a lista contendo os
#pares {tempo leitura ...}
###########################################################################

proc arquivar_medida { info_medida } {
    
    global reg_cad_med
    
    set parametro [$info_medida get_parametro_medido]
    
    set leituras  [lindex [$info_medida get_leituras] 0]
    
#    puts "SAÍDA DE LEITURAS => $leituras"

    mk::file open db orion5star.db    
    
    mk::set $reg_cad_med($parametro) leituras $leituras
    
    mk::file commit db
    
    mk::file close db
}


###########################################################################
#Procedimento para alertar o usuário antes da execução de uma ação
###########################################################################


proc msg_alerta { janela mensagem } {
     
    set resposta [tk_dialog $janela.alerta "Atenção!"  \
		"$mensagem"  info 0 Cancelar Continuar]
    return $resposta
	   
}



##############################################################################
#Chama a tela de configuração e passa o nome do frame da tela de monitoramento
#O uso desse argumento foi apenas para permitir a navegação da tela de 
#configuração para a tela de monitoramento e vice-versa
##############################################################################


tela_config .janela

